// Collidable.java - LHM - 1997-09-08
//
// The Collidable class must be extended for any object which can be dealt
// with in the Collider.
//
// Puck and Wall are two derived classes for the moving and non-moving
// objects currently implemented.
//

package com.lmconsult.elastic;

import java.lang.Cloneable;
import java.awt.*;

public abstract class Collidable
{ public static final int WALL = 0;
  public static final int PUCK = 1;
  public static final int OBSTRUCTION = 2;
  boolean showHighlight = false;		// if true, special highlighting modes displayed
  boolean highlight = false;			// main graphical highlight
  boolean collisionsValid = false;

  abstract int getType();
  // return WALL or PUCK or etc

  abstract void paint(Graphics g);

  public void invalidateCollisions()
  { collisionsValid = false;
  } 

  public void validateCollisions()
  { collisionsValid = true;
  } 

  public void setHighlight()
  { highlight = true;
  }

  public void resetHighlight()
  { highlight = false;
  }

  public void showHighlight(boolean v)
  { showHighlight = v;
  }

}
