// Collision.java - LHM - 1997-08-29
//
// Class defining a collision event, to be used in the collision
// display field (Field.java).
//

package com.lmconsult.elastic;

public class Collision
{ float time;
  Collidable obj1,obj2;

  Collision()
  { time = Long.MAX_VALUE;
    obj1 = null;
    obj2 = null;
  }

  Collision(float t, Collidable o1, Collidable o2)
  { time = t;
    obj1 = o1;
    obj2 = o2;
  }

  boolean preceeds(Collision query)
  { if (query.time<0) return false;
    return (time<query.time);
  }

  boolean checkCollidable(Collidable c)
  { return ((obj1 == c) || (obj2 == c));
  }

}
