package com.lmconsult.elastic;

import java.applet.Applet;
import java.util.Vector;
import java.awt.*;
import java.awt.event.*;

class Forge extends Panel implements AdjustmentListener, TextListener, ColorSelector, FontSelector, Runnable
{ Puck puck;
  BasicField puckHolder;
  Thread myThread;
  LabelledScrollbar sizeScroll, massScroll;
  TextSelectorPanel labelText;
  String newLabel;
  PaintSample colors;
  Color color;

  Forge()
  { puckHolder = new BasicField(new Dimension(150,150));
    puckHolder.setClonable(true);
    puckHolder.setSpikable(true);
    puck = new Puck();
    puck.setCenter(new Point(75,75));
    puck.setRadius(25);
    puck.setMass(5);
    colors = new PaintSample();
    colors.registerColorSelector(this);
    sizeScroll = new LabelledScrollbar("Radius",Scrollbar.VERTICAL,25,5,5,80);
    sizeScroll.addAdjustmentListener(this);
    massScroll = new LabelledScrollbar("Mass",Scrollbar.VERTICAL,5,5,1,25);
    massScroll.addAdjustmentListener(this);
//    labelText = new TextField("",12);
    labelText = new TextSelectorPanel();
    labelText.addTextListener(this);
    labelText.registerFontSelector(this);
    puckHolder.addPuck(puck);
    setLayout(new BorderLayout(5,5));
//    add(colors,"North");
//    add(puckHolder,"Center");
//    add(sizeScroll,"West");
//    add(massScroll,"East");
//    add(labelText,"South");
    add("North",colors);
    add("Center",puckHolder);
    add("West",sizeScroll);
    add("East",massScroll);
    add("South",labelText);
  }

  public void init()
  {
  }

  public void update(Graphics g)
  { paint(g);
  }

  public Insets getInsets()
  { return new Insets(5,5,5,5);
  }

  public void paint(Graphics g)
  { Dimension d = getSize();
    g.setColor(Color.red);
    g.drawRect(0,0,d.width-1,d.height-1);
  }

  public void start()
  { if (myThread == null) 
    { myThread = new Thread(this);
      myThread.start();
    }
  }

  public void stop()
  { myThread = null;
  }

  public void run()
  { while (myThread != null)
    { try {Thread.sleep(200);} catch (InterruptedException e){}
      repaint();
    }
    myThread = null;
  }

  public void colorSelected(Color c)
  { this.color = c;
    puck = (Puck) puckHolder.things.firstElement();
    puck.setColor(c);
    puckHolder.repaint();
  }

  public void textValueChanged(TextEvent e)
  { newLabel = labelText.getText();
    if (newLabel != "")
    { puck = (Puck) puckHolder.things.firstElement();
      puck.setLabel(newLabel);
    }
    puckHolder.repaint();
  }

  public void adjustmentValueChanged(AdjustmentEvent e)
  { Scrollbar a = (Scrollbar) e.getAdjustable();
    int v = e.getValue();
    if (a.getParent()==massScroll)
    { puck = (Puck) puckHolder.things.firstElement();
      puck.setMass(v);
      massScroll.setValue(v);
    } 
    else if (a.getParent()==sizeScroll)
    { puck = (Puck) puckHolder.things.firstElement();
      puck.setRadius(v);
      int m = v/5;
      puck.setMass(m);
      massScroll.setValue(m);
    }
    puckHolder.repaint();
  }

  public void fontSelected(Font f)
  { puck = (Puck) puckHolder.things.firstElement();
    puck.setFont(f);
    puckHolder.repaint();
  }

}
