// PaintSample.java - LHM 1997-09-09
//
// Defines a control for choosing among a set of colors.
//

package com.lmconsult.elastic;

import java.awt.*;
import java.awt.event.*;

class PaintSample extends Panel implements MouseListener
{ Color colorWheel[];
  Color colorChoice;
  ColorSelector listener;
  Dimension patchSize;
  int gap;
  int cols;
  int rows;

  public PaintSample()
  { gap = 5;
    cols = 8;
    rows = 2;
    patchSize = new Dimension(15,10);
    colorWheel = new Color[16];
    colorWheel[0] = Color.black;
    colorWheel[1] = Color.blue;
    colorWheel[2] = Color.cyan;
    colorWheel[3] = Color.darkGray;
    colorWheel[4] = Color.gray;
    colorWheel[5] = Color.green;
    colorWheel[6] = Color.lightGray;
    colorWheel[7] = Color.magenta;
    colorWheel[8] = Color.orange;
    colorWheel[9] = Color.pink;
    colorWheel[10] = Color.red;
    colorWheel[11] = Color.white;
    colorWheel[12] = Color.yellow;
    colorWheel[13] = Color.gray;
    colorWheel[14] = Color.gray;
    colorWheel[15] = Color.gray;
    listener = null;
    colorChoice = Color.white;
    setLayout(new GridLayout(rows,cols,gap,gap));
    for (int i=0;i<colorWheel.length;i++)
    { Splotch spl = new Splotch(colorWheel[i],patchSize);
      spl.addMouseListener(this);
      add(spl);
    }
    setSize(cols*patchSize.width+(cols+1)*gap,rows*patchSize.height+(rows+1)*gap);
  }

  public void mouseClicked(MouseEvent e)
  { Component c = e.getComponent();
    colorChoice = c.getBackground();
    if (listener != null) listener.colorSelected(colorChoice);
  }

  public void mousePressed(MouseEvent e)
  {
  }

  public void mouseReleased(MouseEvent e)
  {
  }

  public void mouseEntered(MouseEvent e)
  {
  }

  public void mouseExited(MouseEvent e)
  {
  }

  public void registerColorSelector(ColorSelector o)
  { listener = o;
  }

  public void paint(Graphics g)
  { paintComponents(g);
  }

}
