package com.lmconsult.elastic;

import java.applet.Applet;
import java.util.Vector;
import java.awt.*;

public class TestField extends Applet implements Runnable
{ Forge forge;
  Thread myThread;
  BasicField field;
  DisplayPane pane;
  PuckMover mover;
  BasicField storage;
  Dimension maxFieldSize=new Dimension(650,250);
  FieldResizer r;
  FlyoverPanel universe;
  
  public TestField()	  
  { universe=new FlyoverPanel();
//	universe.setSize(getSize());
	universe.setSize(750,500);
	universe.setLayout(new FlowLayout(FlowLayout.LEFT));
    Dimension d = new Dimension(215,215);
    field = new CollisionField(d);
	r=new FieldResizer(field,maxFieldSize);
    Puck p = new Puck();
    p.setColor(Color.blue);
    p.setCenter(new Point(100,100));
    p.setProper((float) (Math.random()*50.0-25.0),(float) (Math.random()*50.0-25.0));
    p.setMass(5);
    p.setRadius(20);
    field.addPuck(p);
    p = new Puck();
    p.setColor(Color.red);
    p.setCenter(new Point(50,50));
    p.setProper((float) (Math.random()*50.0-25.0),(float) (Math.random()*50.0-25.0));
    p.setMass(2);
    p.setRadius(10);
    field.addPuck(p);
    p = new Puck();
    p.setColor(Color.orange);
    p.setCenter(new Point(150,150));
    p.setProper((float) (Math.random()*100.0-50.0),(float) (Math.random()*100.0-50.0));
    p.setMass(7);
    p.setRadius(30);
    field.addPuck(p);
    p = new Puck();
    p.setColor(Color.green);
    p.setCenter(new Point(130,50));
    p.setProper((float) (Math.random()*100.0-50.0),(float) (Math.random()*100.0-50.0));
    p.setMass(4);
    p.setRadius(15);
    field.addPuck(p);
    field.startTime();
    forge = new Forge();
    universe.add(forge);
    pane = new DisplayPane();
    pane.enrollField(field);
    universe.add(pane);
    storage = new BasicField(new Dimension(200,200));
    storage.showDirections(true);
    universe.add(storage);
    FlyoverPanel fieldHolder=new FlyoverPanel();
	fieldHolder.setSize(maxFieldSize);
	fieldHolder.setBackground(Color.cyan);
	fieldHolder.setLayout(null);
	fieldHolder.add(field);
	universe.add(fieldHolder);
    mover = new PuckMover(universe,5);
    mover.registerField(field);
    mover.registerField(forge.puckHolder);
    mover.registerField(storage);
	universe.addMover(mover);
    setLayout(null);
	add(universe);
  }

  public void init()
  {
  }

  public void start()
  { if(myThread == null) 
    { myThread = new Thread(this);
      myThread.start();
    }
    forge.start();
  }

  public void stop()
  { myThread = null;
  }

  public void run()
  { while (myThread != null)
    { try {Thread.sleep(200);} catch (InterruptedException e){}
      universe.repaint();
    }
    myThread = null;
  }

}
